#include "../include/LedLib.h"

// Initialisation
// Initialization
LedLib::LedLib(int pixelCount, int pixelPin, int bright){
    this->ledNb = 0;
    this->strip = new Adafruit_NeoPixel(PIXEL_COUNT, PIXEL_PIN, NEO_GRB + NEO_KHZ800);

    this->strip->begin();
    this->strip->show();
    this->strip->setBrightness(bright);
}

// Fonction pour allumer correctement les LEDs en fonction du Rotary
// Function to manage LEDs colors according to the Rotary
void LedLib::actLed(int nb, int start){
  this->ledNb = nb;

  // On éteint tout
  // We shut everything up
  this->strip->clear();

  // Allumer 0 LED ? Inutile
  // Useless to light up 0 LED
  if (nb != 0) {

    // Boucle dans les LEDs
    // Loop in LEDs
    for (int i = start; i <= nb+start; i++) {
        int j = i;
        //TODO: géré le cas ou j > 24
        if(j >= 24){
            j -= 24;
        }

      // Une LED sur deux est blanche : heure entière, l'autre rouge pour 30m
      // One LED out of two is white: whole hour, the other red for 30m
      if (j%2 == 0) {
        this->strip->setPixelColor(j, 255, 255, 255);
      }else{
        this->strip->setPixelColor(j, 255, 0, 0);
      }
    }
  }

  // Maintenant on allume
  // Then light everything up
  this->strip->show();
}

// Fonction qui renvoie le nombre de LEDs allumées
// Function that returns the number of LEDs lit
int LedLib::getledNB(){
  return this->ledNb;
}
//FIXME: this function is broken
void LedLib::okBlink(){
  int tempR;
  int tempV;
  int tempB;

  for (int i = 0; i < 3*2; i++) {
      if(i%2 == 0){
        tempR = 0;
        tempV = 0;
        tempB = 0;

      }else{
        tempR = 75;
        tempV = 181;
        tempB = 67;
      }

      for (int j = 0; j < 24; j++) {
        // On fait clignoter les LEDs pour confirmer
        // We make the LEDs blink to confirm
        this->strip->setPixelColor(j-1, tempR, tempV, tempB);
      }

      this->strip->show();
  }
}
