#include "Program.h"


Program::Program() {

    // Startup Serial
    Serial.begin(MONITOR_SPEED);

    // Startup WiFi
    WiFi.begin(WSSID, PASS);

    Serial.print("Connecting to ");
    Serial.print(WSSID); Serial.println(" ...");

    int i = 0;
    while (WiFi.status() != WL_CONNECTED) { // Wait for the Wi-Fi to connect
        delay(1000);
        Serial.print(++i);
        Serial.print(' ');
    }

    Serial.println('\n');
    Serial.println("Connection established!");
    Serial.print("IP address:\t");
    Serial.println(WiFi.localIP());         // Send the IP address of the ESP8266 to the computer

    // Startup Discord API
    this->discord = new DiscordAPI(DISCORD_HOOK);
    // startup NTP
    this->ntpUDP = new WiFiUDP();
    this->timeClient = new NTPClient(*this->ntpUDP, "pool.ntp.org", 3600*2);//*2 = gnt+2

    this->timeClient->update();
    //this->sendTime("18h12");

    // Startup Rotary
    this->encoder = new SwitchableEncodeur(ENCODER_DT, ENCODER_CLK, ENCODER_SWITCH, 3);

    // Startup LEDs
    this->ledLib = new LedLib(PIXEL_COUNT, PIXEL_PIN, 255);

}

void Program::sendTime(String timeEnd){
    String start = (String)this->timeClient->getHours() + "h";
    int startQuater = this->timeClient->getMinutes()/15;
    if (startQuater != 0){
        start += (String)(startQuater * 15);
    }
    this->discord->sendHeure(start, timeEnd);
}

void Program::loop() {
    if(this->encoder->update()){
        switch (this->encoder->getMenu()){
        case 1:{
            if(!this->ntpUpdated){
                this->timeClient->update();
                this->encoder->resetMenu();
                this->ntpUpdated = true;
            }
            int currentHour = this->timeClient->getHours();
            if(currentHour > 12){
                currentHour -= 12;
            }
            //TODO: debug this shit
            int startLed = currentHour * 2;
            startLed += this->timeClient->getMinutes()/30;
            int encValue = this->encoder->getValue();
            Serial.println(startLed);
            this->ledLib->actLed(encValue+1, startLed-1);
        break;
        }case 2:{
            int finalEncValue = this->encoder->getValue();
            int finalHour = this->timeClient->getHours();
            int finalMinute = this->timeClient->getMinutes();

            Serial.print("finalHour: ");
            Serial.print(finalHour);
            Serial.print("h");
            Serial.print(finalMinute);
            Serial.print(" finalEncValue: ");
            Serial.println(finalEncValue);

            // TODO: send time sur discord
            //this->sendTime()

            this->ledLib->okBlink();
            this->ntpUpdated = false;
            this->encoder->resetMenu();
            this->resetMillis = millis();
        break;
        }}
        Serial.print(this->encoder->getValue());
        Serial.print(" ");
        Serial.println(this->encoder->getMenu());
        //this->ledLib->actLed(this->encoder->getValue(), 5);
    }
    if(this->resetMillis + RESET_TIME == millis()){
        this->encoder->resetMenu();
        this->resetMillis = millis();
        this->ntpUpdated = false;
    }

    // delay(1000);

    // this->timeClient->update();

    // int currentHour = this->timeClient->getHours();
    // Serial.print("Hour: ");
    // Serial.println(currentHour);

    // int currentMinute = this->timeClient->getMinutes();
    // Serial.print("Minutes: ");
    // Serial.println(currentMinute);

    // int currentSecond = this->timeClient->getSeconds();
    // Serial.print("Seconds: ");
    // Serial.println(currentSecond);

    // int currentDayOfWeek = this->timeClient->getDay();
    // Serial.print("Day of week: ");
    // Serial.println(currentDayOfWeek);
}
